﻿Imports Autodesk.AutoCAD.Runtime
Imports Autodesk.AutoCAD.ApplicationServices
Imports Autodesk.AutoCAD.EditorInput
Imports Autodesk.AutoCAD.DatabaseServices
Imports Autodesk.AutoCAD.Geometry
Imports Autodesk.AutoCAD.Windows

Public Class UserControl1

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click

        Dim ed As Editor
        Dim db As Database
        Dim trans As Transaction
        Dim docLock As DocumentLock


        ed = Application.DocumentManager.MdiActiveDocument.Editor

        db = ed.Document.Database

        trans = db.TransactionManager.StartTransaction()

        docLock = Application.DocumentManager.MdiActiveDocument.LockDocument()

        Try
            
            Dim circle As New Circle(New Point3d(0, 0, 0), Vector3d.ZAxis, 100.0)

            Dim btr As BlockTableRecord = CType(trans.GetObject(db.CurrentSpaceId, OpenMode.ForWrite), BlockTableRecord)

            btr.AppendEntity(circle)

            trans.AddNewlyCreatedDBObject(circle, True)

            trans.Commit()
        Catch ex As Exception
            ed.WriteMessage("Error: " + ex.Message)
        Finally
            trans.Dispose()
            docLock.Dispose()
        End Try

    End Sub
End Class
